/*******************************************************************************
* FILE NAME: motor_routines.h
*
* DESCRIPTION:
*  This file contains motor/joystick related filter definitions.
*
* USAGE:
*
*******************************************************************************/

#ifndef __motor_routines_h_
#define __motor_routines_h_

#ifdef VARIABLE_DECLARE
  int ipwm01, ipwm02, ipwm03, ipwm04, ipwm05, ipwm06, ipwm07, ipwm08;
  int ipwm09, ipwm10, ipwm11, ipwm12, ipwm13, ipwm14, ipwm15, ipwm16;
  int ip1_y, ip2_y, ip3_y, ip4_y;
  int ip1_x, ip2_x, ip3_x, ip4_x;
  int ip1_wheel, ip2_wheel, ip3_wheel, ip4_wheel;
  int ip1_aux, ip2_aux, ip3_aux, ip4_aux;
#else
  extern int ipwm01, ipwm02, ipwm03, ipwm04, ipwm05, ipwm06, ipwm07, ipwm08;
  extern int ipwm09, ipwm10, ipwm11, ipwm12, ipwm13, ipwm14, ipwm15, ipwm16;
  extern int ip1_y, ip2_y, ip3_y, ip4_y;
  extern int ip1_x, ip2_x, ip3_x, ip4_x;
  extern int ip1_wheel, ip2_wheel, ip3_wheel, ip4_wheel;
  extern int ip1_aux, ip2_aux, ip3_aux, ip4_aux;
#endif

#define NULLJOYSTICK 9  //This value should be greater than the Victor neutral deadspot

//#define FORWARDLEFTBALANCE 15  // 82 for pwm60, 60 for pwm20, 37 for pwm 127
//#define FORWARDRIGHTBALANCE 0 
//#define BACKWARDLEFTBALANCE 0
//#define BACKWARDRIGHTBALANCE 10 // 63 for pwm20, 16 for pwm 127

void motor_fix_in(void);
void motor_fix_out(void);

void Continuous_Deadband(int *);
void Arm_Deadband(int *);
void Smooth_Joystick(int *);

int  Limit_Mix (int );
void Hold_Position(char, int, int);
void Hold_Arm_Position(char, int, int *);
void Brake(char, int, int);
int PWMBalance(char, int);

#endif
