/*******************************************************************************
* FILE NAME: sensor_routines.h
*
* DESCRIPTION:
*  This file contains sensor related declarations
*
* USAGE:
*
*******************************************************************************/

#ifndef __sensor_routines_h_
#define __sensor_routines_h_


#ifdef VARIABLE_DECLARE
  long GyroSum = 0;
  unsigned char GyroTicks=0; // Time to check the gyro
  int min_gyro=0, max_gyro=0;
  int LeftAmps, RightAmps;
#else
  extern long GyroSum;
  extern unsigned char GyroTicks;
  extern int min_gyro, max_gyro;
  extern int LeftAmps, RightAmps;
#endif

#define ENCODER_INCHES    1628  //tenths of inchs traveled per encoder full revolution (256 counts)
#define TICKS_PER_REV 25600   //Shifted left two decimal places to increase accuracy

/* ADX300 */
  #define DEG90  3461  // Gyro ticks in  90 degrees (8700 for ADX150, 3461 for ADX300)
  #define DEG180 6922  // Gyro ticks in 180 degrees (original)
  #define DEG360 13844 // Gyro ticks in 360 degrees (original)

/* ADX150 */
//  #define DEG90  8700   // Gyro ticks in  90 degrees (8700 for ADX150)
//  #define DEG180 17400  // Gyro ticks in 180 degrees (original)
//  #define DEG360  34800 // Gyro ticks in 360 degrees (original)

#define GYRO_DEGREES (((-GyroSum * 360 * 10) + DEG180) / DEG360)

void Gyro(void);
int  Gyro_Degrees(void);
int  Average_Values(char *, int, char, int *);
int Encoder_PID(long, long, int *, int *);
void Initialize_Interrupts(void);
int Gyro_PID(int,char);
int Gyro_Steering(int, int, int *, int *);
int Gyro_Reset(int);

#endif
