/*******************************************************************************
*
*	TITLE:		sine.c
*	VERSION:	1.0
*	DATE:		18-Feb-2005
*	AUTHOR:		Robert Frank
*				admin@bobbys.us
*
*******************************************************************************/

#include "sine.h"

rom const signed char sine_table[91] = {
  0,   2,   4,   7,   9,  11,  13,  15,  18,  20,  22,  24,  26,  29,  31,  33, 
 35,  37,  39,  41,  43,  46,  48,  50,  52,  54,  56,  58,  60,  62,  64,  65, 
 67,  69,  71,  73,  75,  76,  78,  80,  82,  83,  85,  87,  88,  90,  91,  93, 
 94,  96,  97,  99, 100, 101, 103, 104, 105, 107, 108, 109, 110, 111, 112, 113, 
114, 115, 116, 117, 118, 119, 119, 120, 121, 121, 122, 123, 123, 124, 124, 125, 
125, 125, 126, 126, 126, 127, 127, 127, 127, 127, 127
};

/*******************************************************************************
* FUNCTION NAME: sin
* PURPOSE:       The Sine function
* CALLED FROM:   wherever
* ARGUMENTS:     degrees
* RETURNS:       the sine of the value
*******************************************************************************/

signed int sin(signed int xval)
{
   signed int rval = xval;
   signed int retval=0;
   while(rval > 180) rval -= 360;
   while(rval < -180) rval += 360;
   if(rval>=-90 && rval<=90) return (rval >= 0)? (signed int)sine_table[(unsigned char)rval]:(signed int)(0-sine_table[(unsigned char)(0-rval)]);
   else  return (rval < 0)? (signed int)(0-sine_table[(unsigned char)(0-rval)]):(signed int)(127-sine_table[(unsigned char)rval]);
}

/*******************************************************************************
* FUNCTION NAME: cos
* PURPOSE:       The Cosine function
* CALLED FROM:   wherever
* ARGUMENTS:     radians*30
* RETURNS:       the cosine of the value
*******************************************************************************/

signed int cos(signed int xval)
{
   return (signed int)sin(xval + 90);
}

